C   Program CARTPC is Schachtschneider's CART modified to work on a PC
C   Prepared by Shuliang Zhang in John Bertie's Laboratory in Feb 1993.
C
C   Modified by John Bertie in October 2002 to improve the output and 
C   eliminate the cardwriter output. 
C   Also to simplify the command line by making the program ask for the
C   input filename and change the extension to ".OUT" for the output
C   file
C   Renamed to CARTJB for clarity, because an extra line of input was 
C   introduced.
C.......................................................................
C     CARTESIAN COORDINATE PROGRAM                                     .
C          SCHACHTSCHNEIDER  9/15/63  REVISED  4/15/64                 .
C     THIS PROGRAM COMPUTES THE CARTESIAN COORDINATES OF THE ATOMS IN  .
C     A MOLECULE FROM THE BOND DISTANCES AND BOND ANGLES AND IF DESIRED.
C     WILL CALCULATE THE PRINCIPAL MOMENTS OF INERTIA AND THE PRINCIPAL.
C     CARTESIAN COORDINATES.                                           .
C
      INTEGER*2 ICHIN,ICHOUT
      DIMENSION  COR(500,3),W(500),X(500,3),VBA(3),VCA(3),
     1 RJA(3),TRANS(3,3), PRC(3),CAR(500,3),DNER(3,3),CM(3),TR(3,3),
     2 RT(500),NR(1500),NCO(1500),DAT(1500),D(500),RR(3)
	CHARACTER*80 RECORD1,RECORD2
	CHARACTER*60 RECISO
	CHARACTER*72 PROMPT
	CHARACTER*12 FILEIN,FILEOUT
	CON=.174532925E-01
	
	Write(*,*)'Program CARTJB'
	Prompt='\Enter name of the input file, with extension\'
	Call GETNAM(Prompt,filein)
	Call LENFNAME(filein,len,ier)
	IF(IER.EQ.-1)THEN
	  WRITE(*,*)'NO PERIOD FOUND IN FILENAME'
	  WRITE(*,*)' PROGRAM STOPS; TRY AGAIN.	'
	  STOP
	ENDIF
	fileout=filein(1:len)//'.OUT'
	Write(*,*)'input file is ',filein,', output file is ',fileout
	WRITE(*,*)
	WRITE(*,*)
C
C    NOW TRANSFER *=CHANNEL 5 TO FILEIN AND *=CHANNEL 6 TO FILEOUT 
      ICHIN=5
	ICHOUT=6
      OPEN(UNIT=ICHIN,FILE=FILEIN,STATUS='OLD')
      OPEN(UNIT=ICHOUT,FILE=FILEOUT,STATUS='UNKNOWN')

C.......................................................................
C     READ PROBLEM CONTROL VARIABLES                                        .
C.......................................................................
   90 READ (ICHIN,4) IND
   91 IF (999-IND)  92,999,92
   92 IF (6+IND) 93,243,93
   93 IF (9+IND) 90,94,90
   94 READ (ICHIN,4) IND,NOAT,NISO
    4 FORMAT(I3,3I4)
C.......................................................................
C     THE PROBLEM CONTROL VARIABLES ARE THE FOLLOWING.                 .
C       1.IND=-09 IDENTIFYING THE CONTROL CARD. PUNCHED IN COLUMNS 1-3..
C       2.NOAT, THE NUMBER OF ATOMS IN THE MOLECULE.  LESS THAN 501.   .
C        PUNCHED IN COLUMNS 5-7.                                       .
C        3.NISO, THE NUMBER OF ADDITIONAL ISOTOPICALLY SUBSTITUTED     .
C         MOLECULES . NISO=0 IF NO ISOTOPIC MOLECULES.                 .
C         PUNCHED IN COLUMNS 9-11.                                     .
C   C     4.NOPT, OUTPUT AND MOMENT OF INERTIA OPTION CONTROL.          .
C   C      IF NOPT=-1 BOTH THE RAW AND THE PRINCIPAL CARTESIANS         .
C   C      ARE WRITTEN TO THE OUTPUT FILE.                              .
C   C      IF NOPT=0 ONLY THE PRINCIPAL CARTESIANS ARE WRITTEN.         .
C   C      IF NOPT=1 THE PRINCIPAL MOMENTS AND COORDINATES ARE NOT      .
C   C      EVALUATED, ONLY THE RAW CARTESIANS ARE WRITTEN.              .
C   C  NOPT IS PUNCHED IN COLUMNS 14 AND 15                             .
C     ---------------------------------------------------------------- .
C     READ TWO PROBLEM INFORMATION LINES.                              .
C.......................................................................
      READ (ICHIN,'(A)')RECORD1
	READ (ICHIN,'(A)')RECORD2
C  READ INFORMATION ABOUT THE ISOTOPE WHOSE MASS IS IN THE INPUT DATA
      READ(ICHIN,'(A)') RECISO
C.......................................................................
C     INPUT DATA FOLLOWS, ONE LINE DEFINING EACH ATOM.                 .
C     EACH ATOM DEFINITION LINE CONTAINS:                              .
C             DATA                                 COLUMNS             .
C        NO  NUMBER OF ATOM N BEING DEFINED          1-3               .
C        NA   THE 3 ENTRIES NA, NB & NC ARE THE      4-6               .
c        NB   NUMBERS OF ATOMS A, B & C WHICH        7-9               .
C        NC   ARE USED TO DEFINE ATOM N              10-12             .
C        R   DISTANCE NO-NA, i.e FROM ATOM N to A    13-24 (F12.6)     .
C        TE      ANGLE NO-NA-NB, i.e., A-B-C         25-36 (F12.6)     .
C        PH  DIHEDRAL ANGLE NO-NA-NB-NC, i.e., NABC  37-48 (F12.6)     .
C        WT      MASS OF ATOM N                      49-60 (F12.6)     .
C     ATOM DEFINITION LINES MUST BE IN ORDER OF NO=1,2,3,   ETC.  AND  .
C     NA,NB, AND NC MUST BE LESS THAN NO.                              .
C      IF TE=0.0 THE ANGLE WILL BE TAKEN TO BE TETRAHEDRAL.            .
C         NO=1 DEFINES THE ORIGIN                                      .
C     THE LINE NO=1 TO NO=2 DEFINES THE +X AXIS.                       .
C     ATOMS NO=1,NO=2,NO=3 DEFINE THE XY PLANE                         .
C     FOR A RIGHT HANDED COORDINATE SYSTEM DIHEDRAL ANGLES ARE DEFINED .
C     BY VIEWING THE CONFIGURATION FROM THE NC DIRECTION ALONG THE     .
C     NB-NA AXIS OR THE NA-NB AXIS DEPENDING ON WHETHER ATOM C IS      .
C     BONDED TO ATOM B OR A.  THE ANGLE IS DEFINED POSITIVE FOR A      .
C     CLOCKWISE ROTATION OF ATOM C INTO THE  N-A-B PLANE.              .
C.......................................................................
      JOKE=0
	WRITE(ICHOUT,*)' PROGRAM CARTJB'
      WRITE (ICHOUT,'(A)') RECORD1
	WRITE (ICHOUT,'(A)') RECORD2
      WRITE(ICHOUT,*)
      WRITE(ICHOUT,50)
   50 FORMAT (10x,'INPUT VALENCE COORDINATES')
      READ  (ICHIN,10)NO,NA,NB,NC,R,TE,PH,WT
   10 FORMAT(4I3,4F12.6)
      WRITE (ICHOUT,10)NO,NA,NB,NC,R,TE,PH,WT
      W(NO)=WT
      COR(NO,1)=0.0
      COR(NO,2)=0.0
      COR(NO,3)=0.0
      READ  (ICHIN,10)NO,NA,NB,NC,R,TE,PH,WT
      WRITE (ICHOUT,10)NO,NA,NB,NC,R,TE,PH,WT
      COR(NO,1)=R
      COR(NO,2)=0.0
      COR(NO,3)=0.0
      W(NO)=WT
      READ  (ICHIN,10)NO,NA,NB,NC,R,TE,PH,WT
      WRITE (ICHOUT,10)NO,NA,NB,NC,R,TE,PH,WT
      W(NO)=WT
      IF(TE)120,118,120
  118 CS=-0.33333333
      SS=0.94280907
      GO TO 121
  120 CS=COS(CON*TE)
      SS=SIN(CON*TE)
  121 IF (NA-1)128,122,128
  122 COR(NO,1)=COR(NA,1)+R*CS
      GO TO 129
  128 COR(NO,1)=COR(NA,1)-R*CS
  129 COR(NO,2)=R*SS
      COR(NO,3)=0.0
      IF (NOAT-3) 96,161,130
  130 DO 160 I=4,NOAT
      READ  (ICHIN,10)NO,NA,NB,NC,R,TE,PH,WT
      WRITE (ICHOUT,10)NO,NA,NB,NC,R,TE,PH,WT
      W(NO)=WT
      IF(TE)133,132,133
  132 CS=-0.33333333
      SS=0.94280907
      GO TO 135
  133 CS=COS(CON*TE)
      SS=SIN(CON*TE)
  135 DSQ=0
      DO 138 M=1,3
      VBA(M)=COR(NB,M)-COR(NA,M)
      VCA(M)=COR(NC,M)-COR(NA,M)
  138 DSQ=DSQ+VBA(M)**2
      RAB=SQRT(DSQ)
      SCALE=0.0
      DO 142 M=1,3
      TRANS(M,1)=VBA(M) /RAB
  142 SCALE=SCALE+ TRANS(M,1)*VCA(M)
      DSQ=0.0
      DO 146 M=1,3
      RJA(M)=VCA(M)-SCALE*TRANS(M,1)
  146 DSQ=DSQ+RJA(M)**2
      RAJ=SQRT(DSQ)
      DO 148 M=1,3
  148 TRANS(M,2)=RJA(M) / RAJ
      TRANS(1,3)=TRANS(2,1)*TRANS(3,2)-TRANS(3,1)*TRANS(2,2)
      TRANS(2,3)=TRANS(3,1)*TRANS(1,2)-TRANS(1,1)*TRANS(3,2)
      TRANS(3,3)=TRANS(1,1)*TRANS(2,2)-TRANS(2,1)*TRANS(1,2)
      PRC(1)=R*CS
      PRC(2)=R*SS*COS(CON*PH)
      PRC(3)=R*SS*SIN(CON*PH)
      DO 160 M=1,3
      COR(NO,M)=COR(NA,M)
      DO 160 K=1,3
  160 COR(NO,M)=COR(NO,M)+TRANS(M,K)*PRC(K)
C
C     WRITE CARTESIANS IN INPUT AXES                                      .
  161 WRITE(ICHOUT,*)
      WRITE(ICHOUT,*)'  CARTESIAN COORDINATES IN INPUT AXIS FRAME'
	WRITE(ICHOUT,*)'  NOTE THAT THESE ARE INDEPENDENT OF ISOTOPE'
	WRITE(ICHOUT,'(A)')RECISO
      WRITE (ICHOUT,60)
   60 FORMAT(' ATOM NO.       X           Y          Z          MASS')
      DO 164 I=1,NOAT
  164 WRITE (ICHOUT,62)I,(COR(I,M),M=1,3),W(I)
   62 FORMAT(4X,I3,3X,3F12.6,F13.6)
C.......................................................................
C     WRITE CARTESIANS IN INPUT AXES IN FORMAT FOR GMAT INPUT                                      .
      NX=0
      DO 1225 I =1,NOAT
      DO 1225 M=1,3
      IF(0.000005-ABS(COR(I,M)))1220,1220,1224
 1220 NX= NX+1
      NR(NX)=M
      NCO(NX)=I
      DAT(NX)=COR(I,M)
      GO TO 1225
 1224 COR(I,M)= 0.0
 1225 CONTINUE
      NX=NX+1
      NR(NX)=-1
      NCO(NX)=0.0
      DAT(NX)=0.0
 1228 WRITE(ICHOUT,*)
      WRITE(ICHOUT,*)'  CARTESIAN COORDINATES IN INPUT AXIS FRAME'
      WRITE(ICHOUT,*)'  IN FORMAT FOR INPUT TO GMAT'
	WRITE(ICHOUT,*)'  NOTE THAT THESE ARE INDEPENDENT OF ISOTOPE'
  229 WRITE (ICHOUT,72)(NR(I),NCO(I),DAT(I),I=1,NX)
C
      WRITE(ICHOUT,*)
      WRITE(ICHOUT,*)' INTERATOMIC DISTANCES CHECK'
      DO 1236 I=1,NOAT
      DO 1234 J=1,NOAT
      DSQ=0.0
      DO 1233 M=1,3
      RR(M)=COR(J,M)-COR(I,M)
 1233 DSQ=DSQ+RR(M)*RR(M)
 1234 D(J)=SQRT(DSQ)
 1236 WRITE (ICHOUT,69)I,(D(J),J=1,NOAT)
   69 FORMAT (1X,'ATOM',I3,/,(1X,8(F9.6,1X)))
C
C     FIND CENTER OF MASS                                              .
  168 WT=0.0
      DO 170 I=1,NOAT
  170 WT=WT+W(I)
      DO 180 M=1,3
      CM(M)=0.0
      DO 179 I=1,NOAT
  179 CM(M)=CM(M)+W(I)*COR(I,M)
  180 CM(M)=CM(M)/ WT
      DO 185 I=1,NOAT
      RT(I)=0.0
      DO 185 M=1,3
      X(I,M)=COR(I,M)-CM(M)
  185 RT(I)=RT(I)+(X(I,M))**2
      DO 190 I=1,3
      DO 190 J=1,3
      DNER(I,J)=0.0
      DO 190 K=1,NOAT
      IF(I-J)189,187,189
  187 DNER(I,J)=DNER(I,J)+W(K)*(RT(K)-X(K,I)*X(K,I))
      GO TO 190
  189 DNER(I,J)=DNER(I,J) -W(K)* X(K,I)*X(K,J)
  190 CONTINUE
      WRITE(ICHOUT,*)
	WRITE(ICHOUT,'(A)')RECISO

      WRITE (ICHOUT,80)WT,(CM(M),M=1,3)
   80 FORMAT('  TOTAL MASS=',F12.6,/,2X,'CENTER OF MASS=',3(F10.6,2X))
      WRITE(ICHOUT,*)'   MOMENT OF INERTIA TENSOR'
      DO 192 I=1,3
  192 WRITE (ICHOUT,82)(DNER(I,J),J=1,3)
   82 FORMAT(3F12.6)
      NROT=0
      N=3
      IEGEN=0
C.......................................................................
C     FIND TRANFORMATION TO PRINCIPAL AXES.                            .
C.......................................................................
      CALL HDIAG (DNER,N,IEGEN,TR,NROT)
	WRITE(ICHOUT,*)
	WRITE(ICHOUT,'(A)')RECISO
	WRITE(ICHOUT,*)'  PRINCIPAL MOMENT OF INERTIA'
  200 WRITE (ICHOUT,84)(DNER(I,I),I=1,3)
   84 FORMAT(3X,3F12.6)
      WRITE(ICHOUT,*)' AND TRANSFORMATION TENSOR' 
  201 DO 202 I=1,3
  202 WRITE (ICHOUT,82)(TR(I,J),J=1,3)
C.......................................................................
C     ROTATE TO PRINCIPAL AXES.                                        .
C.......................................................................
      DO 210 I=1,NOAT
      DO 210 J=1,3
      CAR(I,J)=0.0
      DO 210 K=1,3
  210 CAR(I,J)=CAR(I,J)+TR(K,J)*X(I,K)
      WRITE(ICHOUT,*)
	WRITE(ICHOUT,'(A)')RECISO
	WRITE(ICHOUT,*)'   PRINCIPAL CARTESIAN COORDINATES'
	WRITE(ICHOUT,*)'  NOTE THAT THESE DIFFER FOR DIFFERENT ISOTOPES'
      WRITE (ICHOUT,60)
      DO 215 I=1,NOAT
  215 WRITE (ICHOUT,62)I,(CAR(I,M),M=1,3),W(I)
      NX=0
C.......................................................................
C     WRITE PRINCIPAL CARTESIANS IN FORMAT FOR INPUT TO GMAT
C.......................................................................
  220 DO 225 I=1,NOAT
      DO 225 M=1,3
      IF(0.000005-ABS(CAR(I,M)))221,221,224
  221 NX=NX+1
      NR(NX)=M
      NCO(NX)=I
      DAT(NX)=CAR(I,M)
      GO TO 225
  224 CAR(I,M)=0.0
  225 CONTINUE
      NX=NX+1
      NR(NX)=-1
      NCO(NX)=0.0
      DAT(NX)=0.0
   	WRITE(ICHOUT,*)
      WRITE(ICHOUT,*)'  PRINCIPAL CARTESIAN COORDINATES'
      WRITE(ICHOUT,*)'  IN FORMAT FOR INPUT TO GMAT'
	  WRITE(ICHOUT,*)'  NOTE THAT THESE DIFFER FOR DIFFERENT ISOTOPES'
	  WRITE(ICHOUT,'(A)')RECISO
	  WRITE (ICHOUT,72 ) (NR(I),NCO(I),DAT(I),I=1,NX)
   72 FORMAT (4(2I3,F12.6))
  240 if(niso) 96,96,242
C   WRITE 4 BLANK LINES ON THE PAGE BEFORE RETURNING FOR A FURTHER RUN.
   96 WRITE(ichout,*)
      WRITE(ichout,*)
      WRITE(ichout,*)
      WRITE(ichout,*)
      GO TO 90

C.......................................................................
C     READ MASS ID CARD FOR NISO GREATER THEN ZERO                     .
C      -06 IN COLUMN 1-3       ALPHA-NUMERIC INFORMATION ON REMAINDER  .
C.......................................................................
  242 READ  (ICHIN,20)IND,RECISO
   20 FORMAT(I3,A)
      IF (6+IND) 95,243,95
C   WRITE 4 BLANK LINES ON THE PAGE BEFORE RETURNING FOR A FURTHER RUN.
   95 WRITE(ichout,*)
      WRITE(ichout,*)
      WRITE(ichout,*)
      WRITE(ichout,*)
      GO TO 91
C.......................................................................
C     READ NOAT ISOTOPIC MASSES IN ORDER 1 TO NOAT   (6F12.6)          .
C.......................................................................
  243 READ  (ICHIN,22)(W(I),I=1,NOAT)
   22 FORMAT(6F12.6)
      WRITE(ICHOUT,*)
	  WRITE(ICHOUT,*)
	  WRITE(ICHOUT,*)'   NEXT ISOTOPE'
      GO TO 168
C  999 CALL EXIT
999   close(ICHIN)
      close(ICHOUT)
      stop
      END



      SUBROUTINE  HDIAG (H,N,IEGEN,U,NR)
      DIMENSION H(3,3),U(3,3),X(3),IQ(3)
C.......................................................................
C     MIHDI3,FORTRANIV  DIAGONALIZATION OF A REAL SYMMETRIC MATRIX BY  .
C     THE JACOBI METHOD.                                               .
C       PROGRAMMED BY CORBATO AND M. MERWIN OF MIT                     .
C     CALLING SEQUENCE FOR DIAGONALIZATION                             .
C     CALL HDIAG( H, N, IEGEN, U, NR)                                  .
C     WHERE H IS THE ARRAY TO BE DIAGONALIZED                          .
C     N IS THE ORDER OF THE MATRIX, H.                                 .
C     IEGEN MUST BE SET UNEQUAL TO ZERO IF ONLY EIGENVALUES ARE TO BE  .
C     COMPUTED.                                                        .
C     IEGEN MUST BE SET EQUAL TO ZERO IF EIGENVALUES AND EIGENVECTORS  .
C     ARE TO BE COMPUTED.                                              .
C     U IS THE UNITARY MATRIX USED FOR FORMATION OF THE EIGENVECTORS.  .
C     NR IS THE NUMBER OF ROTATIONS.                                   .
C     A DIMENSION STATEMENT MUST BE INSERTED IN THE SUBROUTINE.        .
C     DIMENSION H(N,N), U(N,N), X(N), IQ(N)                            .
C     COMPUTER MUST OPERATE IN FLOATING TRAP MODE                      .
C     THE SUBROUTINE OPERATES ONLY ON THE ELEMENTS OF H THAT ARE TO THE.
C     RIGHT OF THE MAIN DIAGONAL.  THUS, ONLY A TRIANGULAR             .
C     SECTION NEED BE STORED IN THE ARRAY H.                           .
C.......................................................................
      IF (IEGEN) 15,10,15
10     DO 13 I=1,N
      DO 14 J=1,N
      IF(I-J)12,11,12
   11 U(I,J)=1.0
      GO TO 14
   12 U(I,J)=0.0
   14 CONTINUE
13     CONTINUE
   15 NR = 0
      IF (N-1) 1000,1000,17
C.......................................................................
C     SCAN FOR LARGEST OFF DIAGONAL ELEMENT IN EACH ROW                .
C     X(I) CONTAINS LARGEST ELEMENT IN THE  ITH ROW                    .
C     IQ(I) HOLDS SECOND SUBSCRIPT DEFINING POSITION OF ELEMENT        .
C.......................................................................
   17 NMI1=N-1
      DO 31 I=1,NMI1
      X(I) = 0.0
      IPL1=I+1
      DO 30 J=IPL1,N
      IF(X(I)-ABS( H(I,J))) 20,20,30
   20 X(I)=ABS(H(I,J))
      IQ(I)=J
   30 CONTINUE
31     CONTINUE
C.......................................................................
C     SET INDICATORS FOR SHUT-OFF.RAP=2**-27,NR=NO. OF ROTATIONS       .
C.......................................................................
      RAP=.745058059E-08
      HDTEST=1.0E38
C.......................................................................
C     FIND MAXIMUM OF X(I) S FOR PIVOT ELEMENT AND                     .
C     TEST FOR END OF PROBLEM                                          .
C.......................................................................
   40 DO 70  I=1,NMI1
      IF (I-1) 60,60,45
   45 IF(XMAX-X(I)) 60,70,70
   60 XMAX=X(I)
      IPIV=I
      JPIV=IQ(I)
   70 CONTINUE
C.......................................................................
C     IS MAX. X(I) EQUAL TO ZERO, IF LESS THAN HDTEST,REVISE HDTEST    .
C.......................................................................
      IF (XMAX) 1000,1000,80
   80 IF( HDTEST) 90,90,85
   85 IF (XMAX - HDTEST) 90,90,148
   90 HDIMIN = ABS( H (1,1) )
      DO 110  I=2,N
      IF (HDIMIN - ABS( H (I,I))) 110,110,100
  100 HDIMIN=ABS(H(I,I))
  110 CONTINUE
      HDTEST = HDIMIN*RAP
C.......................................................................
C     RETURN IF MAX.H(I,J)LESS THAN(2**-27)ABSF(H(K,K)-MIN)            .
C.......................................................................
      IF (HDTEST-XMAX) 148,1000,1000
  148 NR= NR+1
C.......................................................................
C     COMPUTE TANGENT, SINE AND COSINE,H(I,I),H(J,J)                   .
C.......................................................................
      XDIF=H(IPIV,IPIV)-H(JPIV,JPIV)
        XO=SIGN(2.0,XDIF)*H(IPIV,JPIV)
      XS=XDIF**2+4.0*H(IPIV,JPIV)**2
  150 TANG=XO / (ABS(XDIF)  + SQRT(XS))
      COSINE=1.0/SQRT(1.0+TANG**2)
      SINE=TANG*COSINE
      HII=H(IPIV,IPIV)
      H(IPIV,IPIV)=COSINE**2*(HII+TANG*(2.0*H(IPIV,JPIV)+TANG*H(JPIV,JPI
     1V)))
      H(JPIV,JPIV)=COSINE**2*(H(JPIV,JPIV)-TANG*(2.0*H(IPIV,JPIV)-TANG*H
     1 II))
      H(IPIV,JPIV)=0.0
C.......................................................................
C      PSEUDO RANK THE EIGENVALUES                                     .
C     ADJUST SINE AND COS FOR COMPUTATION OF H(IK) AND U(IK)           .
C.......................................................................
      IF ( H(IPIV,IPIV) - H(JPIV,JPIV)) 152,153,153
  152 HTEMP = H(IPIV,IPIV)
      H(IPIV,IPIV) = H(JPIV,JPIV)
      H(JPIV,JPIV)=HTEMP
C.......................................................................
C     RECOMPUTE SINE AND COS                                           .
C.......................................................................
      HTEMP = SIGN(1.0, -SINE) * COSINE
      COSINE =ABS(SINE)
      SINE =HTEMP
  153 CONTINUE
C.......................................................................
C     INSPECT THE IQS BETWEEN I+1 AND N-1 TO DETERMINE                 .
C     WHETHER A NEW MAXIUM VALUE SHOULD BE COMPUTED SINCE              .
C     THE PRESENT MAXIMUM IS IN THE I OR J ROW.                        .
C.......................................................................
      DO 350 I=1,NMI1
      IF(I-IPIV)210,350,200
  200 IF (I-JPIV) 210,350,210
  210 IF(IQ(I)-IPIV) 230,240,230
  230 IF(IQ(I)-JPIV) 350,240,350
  240 K=IQ(I)
  250 HTEMP=H(I,K)
      H(I,K)=0.0
      IPL1=I+1
      X(I) =0.0
C.......................................................................
C     SEARCH IN DEPLETED ROW FOR NEW MAXIMUM                           .
C.......................................................................
      DO 320 J=IPL1,N
      IF ( X(I) -ABS( H(I,J)) ) 300,300,320
  300 X(I) = ABS(H(I,J))
      IQ(I)=J
  320 CONTINUE
      H(I,K)=HTEMP
  350 CONTINUE
      X(IPIV) =0.0
      X(JPIV) =0.0
C.......................................................................
C     CHANGE THE ORDER ELEMENTS OF H                                   .
C.......................................................................
      DO 530 I=1,N
      IF (I-IPIV) 370,530,420
  370 HTEMP = H(I,IPIV)
      H(I,IPIV)= COSINE*HTEMP + SINE*H(I,JPIV)
      IF ( X(I) - ABS( H(I,IPIV)) )380,390,390
  380 X(I) = ABS(H(I,IPIV))
      IQ(I) = IPIV
  390 H(I,JPIV) = - SINE*HTEMP + COSINE*H(I,JPIV)
      IF ( X(I) - ABS( H(I,JPIV)) ) 400,530,530
  400 X(I) = ABS(H(I,JPIV))
      IQ(I) = JPIV
      GO TO 530
  420 IF(I-JPIV) 430,530,480
  430 HTEMP = H(IPIV,I)
      H(IPIV,I) = COSINE*HTEMP + SINE*H(I,JPIV)
      IF ( X(IPIV) - ABS(H(IPIV,I)) ) 440,450,450
  440 X(IPIV) = ABS(H(IPIV,I))
      IQ(IPIV) = I
  450 H(I,JPIV) = - SINE*HTEMP + COSINE*H(I,JPIV)
      IF (X(I) - ABS( H(I,JPIV)) ) 400,530,530
  480 HTEMP = H(IPIV,I)
      H(IPIV,I) = COSINE*HTEMP + SINE*H(JPIV,I)
      IF ( X(IPIV) - ABS( H(IPIV,I)) ) 490,500,500
  490 X(IPIV) = ABS(H(IPIV,I))
      IQ(IPIV) = I
  500 H(JPIV,I) = - SINE*HTEMP + COSINE*H(JPIV,I)
      IF ( X(JPIV) - ABS( H(JPIV,I)) )510,530,530
  510 X(JPIV) = ABS(H(JPIV,I))
      IQ(JPIV) = I
  530 CONTINUE
C.......................................................................
C     TEST FOR COMPUTATION OF EIGENVECTORS                             .
C.......................................................................
      IF(IEGEN) 40,540,40
  540 DO 550 I=1,N
      HTEMP=U(I,IPIV)
      U(I,IPIV)=COSINE*HTEMP+SINE*U(I,JPIV)
  550 U(I,JPIV)= -SINE*HTEMP+COSINE*U(I,JPIV)
      GO TO 40
 1000 RETURN
      END


	SUBROUTINE GETNAM(PROMPT,filenam)
      CHARACTER*12  filenam
      CHARACTER*72  PROMPT
C
C	THIS ROUTINE PROMPTS FOR A FILENAME AND CHECKS THAT IT DOES
C	EXIST. I NEED THIS ALL THE TIME.
C
C	THIS ROUTINE IS PART OF THE IMX LIKE SPECTRAL ANALYSIS PACKAGE
C	CONVERTED TO RUN ON XXX/PC COMPATIBLE COMPUTERS. IT IS WRITTEN
C	WITH MICROSOFT FORTRAN 77 VERSION 4.0 AND USES THE MEDIA
C	CYBERNETICS HALO GRAPHICS.
C	WRITTEN AND MODIFIED BY KENNETH W. VAN EVERY
C	UC RIVERSIDE, CA.
C     MODIFIED BY JOHN BERTIE, UNIVERSITY OF ALBERTA, OCTOBER 2002
C     TO MAKE THE ERROR CHECKING WORK.
C     (IFLAG WAS THE CHECK, BUT WAS NEVER SET)
C
      LOGICAL FEXIST
      ITR=1
      CALL LENSTR(PROMPT,LEN,IER)
3     WRITE(*,'(2(A)\)') PROMPT(1:LEN),' '
4     READ(*,'(A)',ERR=9001) filenam

C	MAKE SURE THE FILE EXISTS.
      INQUIRE(FILE=filenam,EXIST=FEXIST)
      IF( .NOT. FEXIST ) THEN
            WRITE(*,*) ' GETNAME: FILE NOT FOUND - RETYPE.'
            ITR=ITR+1
            IF( ITR .GE.5 ) RETURN
            GO TO 3
      ENDIF
      RETURN
9001  CALL MSG('\AN ERROR WAS ENCOUNTERED READING\')
      CALL MSG('\THAT NAME,  PLEASE RE-ENTER OR\')
      CALL MSG('\CHOOSE ANOTHER NAME\')
      GO TO 3
9002  CALL MSG('\SOMETHING IS WRONG WITH THE FILENAME\')
      CALL MSG('\YOU ENTERED.  PLEASE CHECK FOR ERRORS\')
      CALL MSG('\OR ILLEGAL CHARACTERS\')
      GO TO 3
      END

      SUBROUTINE LENSTR(ASTR,LEN,IER)
      CHARACTER*100 ASTR
      INTEGER*4     IER
C
C	RETURNS THE LENGTH (LEN) OF A STRING ASTR WHICH HAS UNIQUE
C	DELIMITERS AT THE START AND END. DELIMITER MAY BE ANY
C	CHARACTER WHICH DOES NOT OCCUR WITHIN THE VALID STRING.
C	A \ CHARACTER IS RECOMMENDED AS CONVENTION BUT THE ROUTINE
C	DOES NOT CARE.
C   RETURNS IER=1 IF ALL IS OK AND IER=-1 IF IT CAN NOT FIND THE LENGTH
C
C	THIS ROUTINE IS PART OF THE IMX LIKE SPECTRAL ANALYSIS PACKAGE
C	CONVERTED TO RUN ON XXX/PC COMPATIBLE COMPUTERS. IT IS WRITTEN
C	WITH MICROSOFT FORTRAN 77 VERSION 4.0 AND USES THE MEDIA
C	CYBERNETICS HALO GRAPHICS.
C	WRITTEN AND MODIFIED BY KENNETH W. VAN EVERY
C	UC RIVERSIDE, CA.
C
C
      IER=1
      DO 1 I=2,100
            IF( ASTR(I:I) .EQ. ASTR(1:1) ) THEN
                  LEN=I-1
                  RETURN
            ENDIF
1     CONTINUE
      IER=-1
      RETURN
      END


      SUBROUTINE MSG(ASTRING)
C
C	THIS ROUTINE IS PART OF THE IMX LIKE SPECTRAL ANALYSIS PACKAGE
C	CONVERTED TO RUN ON XXX/PC COMPATIBLE COMPUTERS. IT IS WRITTEN
C	WITH MICROSOFT FORTRAN 77 VERSION 4.0 AND USES THE MEDIA
C	CYBERNETICS HALO GRAPHICS.
C	WRITTEN  BY  KENNETH W. VAN EVERY  UC RIVERSIDE, CA.
C
      CHARACTER*100 ASTRING
      INTEGER*4     IER
      CALL LENSTR(ASTRING,J,IER)
2     WRITE(*,'(1X,A)') ASTRING(2:J)
      RETURN
      END


	  SUBROUTINE LENFNAME(ASTR,LEN,IER)
      CHARACTER*30 ASTR
      INTEGER*4     IER
C
C	RETURNS THE LENGTH (LEN) OF THE PART OF A FILENAME ASTR BEFORE THE
C     PERIOD
C	WRITTEN BY JOHN BERTIE, 17 OCTOBER, 2002.
c     RETURNS IER=1 IF ALL IS OK AND IER=-1 IF NO PERIOD IS FOUND.
C
C	THIS ROUTINE IS BASED ON LENSTR, WHICH IS PART OF THE IMX LIKE 
c     SPECTRAL ANALYSIS PACKAGE WRITTEN BY KENNETH W. VAN EVERY
C	UC RIVERSIDE, CA.
C
      IER=1
      DO 1 I=2,30
            IF( ASTR(I:I) .EQ. '.' ) THEN
                  LEN=I-1
                  RETURN
            ENDIF
1     CONTINUE
      IER=-1
      RETURN
      END

